/*
This skeleton was autogenerated by Bowser's Blueprints. It will NOT be replaced
on rebuilding, so you are free to modify this file.

Do NOT use the .org, .orga, or .headersize commands in this file or files
included by this file. Anything that needs to write to elsewhere in the ROM
should go into globals.asm instead.

This file is intended to be used for global behaviour scripts. You can
implement the main part of your behaviour scripts (everything except the first
0x00 command) in another file linked using misc-injected.asm, then reference
that behaviour script in this file using the @link_behaviour macro provided
below (or @link_behaviour_segmented if you are using a segmented address).
*/

; Object Lists
.definelabel @EXPLOSION, 0x2 ; things that can damage other objects (bombs, explosions, and bouncy cork boxes)
.definelabel @GENERIC, 0x4 ; nothing too special about this list. Pretty much equivalent to OBJ_LIST_LEVEL
.definelabel @INTERACTIVE, 0x5 ; objects that can detect hitbox collisions with other objects (not just Mario!)
.definelabel @LEVEL, 0x6 ; nothing too special about this list. Pretty much equivalent to OBJ_LIST_GENERIC
.definelabel @DEFAULT, 0x8 ; where objects without an object list explicitly set go. Does not process collision
.definelabel @SURFACE, 0x9 ; objects with triangle collision
.definelabel @MAGNETIC, 0xA ; objects that Mario can climb (poles/trees) or that pull him in (tornado/whirlpool) or push him (wind)
.definelabel @SPAWNER, 0xB ; objects that spawn other objects. Objects in this list get processed first
.definelabel @PARTICLES, 0xC ; unimportant objects that will get automatically despawned if more important objects need to load

.macro @link_behaviour_segmented, objectList, segmentedAddress
	.byte 0x00, objectList, 0x00, 0x00
	.word 0x04000000, segmentedAddress
.endmacro

.macro @link_behaviour, objectList, virtualAddress
	@link_behaviour_segmented objectList, (virtualAddress - 0x80000000)
.endmacro

; Link your behaviour scripts here. They will start at segmented address
; 0x00367500 and increase by 0xC (12) for each additional behaviour.


; Examples:
;
; // 0x00367500
; @link_behaviour @GENERIC, beh_my_behaviour_1
;
; // 0x0036750C
; @link_behaviour @SPAWNER, beh_my_behaviour_2
;
; etc.
