/*
DO NOT MODIFY THE CONTENTS OF THIS FILE. CHANGES MADE WILL BE LOST WHEN YOU
NEXT REBUILD YOUR ROM IN BOWSER'S BLUEPRINTS.

This file was autogenerated by Bowser's Blueprints. This file provides code
hooks for your custom assembly code. Do not modify this file, as changes will be
lost when you next build. Instead, modify the files in this folder:
${ROM_NAME}-asm/
If you need to add your own shims, put them in global.asm instead of here.

The following files in the asm directory are autogenerated when you first build
your rom in Bowser's Blueprints, but will not be replaced on subsequent builds
with the exception of bb-refs.asm and camera-triggers.asm, which are replaced
and should not be altered:

bb-refs.asm
	Autogenerated labels for resources in your ROM. (Do not modify)
	
camera-triggers.asm
	Autogenerated file that writes custom camera trigger code pointers
	
defines.asm
	Non-executable label defines
	
behaviour-script-linkers.asm
	A place where you can optionally put short 12 byte behaviour scripts that
	call into your main behaviour script implementations, giving you a
	consistent unchanging address to use when placing your objects.
	
on-game-start.asm
	Code that runs once when the game starts.
	
on-mario-step-begin.asm
	Code that runs once every frame just before Mario's behaviour script runs.
	Does not run if the Mario object does not exist.
	
on-mario-step-end.asm
	Code that runs once every frame just after Mario's behaviour script runs.
	Does not run if the Mario object does not exist.
	
on-frame-end.asm
	Code that runs once every frame just before the buffer swap.
	
on-hud-render.asm
	Code that runs every frame after the HUD renders. Your code that draws UI
	elements should go here.
	
on-level-load.asm
	Code that runs when entering a new level
	
on-area-load.asm
	Code that runs when entering a new area
	
misc-injected.asm
	Miscellaneous code that gets injected into free space in RAM

global.asm
	Shims and code that overwrites other code
*/

.open "${ROM_NAME}",0x7FB9AE40
.erroronwarning on
.relativeinclude on
.n64

.area 0
.include "./${ASM_DIR}/bb-refs.asm"
.include "./${ASM_DIR}/modules/props.asm"
.include "./${ASM_DIR}/modules/definitions.asm"
.include "./${ASM_DIR}/defines.asm"
.endarea

; Bowser's Blueprints automatically copies user code from 0x7CC6C0 in the ROM
; to 0x80367500 in memory.
.headersize 0x7FB9AE40
.orga 0x7CC6C0
.area 0x11200

.include "./${ASM_DIR}/behaviour-script-linkers.asm"

.include "./${ASM_DIR}/modules/strings.asm"
.include "./${ASM_DIR}/modules/scopes.asm"
.include "./${ASM_DIR}/modules/cameras.asm"

@on_game_start:
ADDIU SP, SP, 0xFFE8
SW RA, 0x14 (SP)
.include "./${ASM_DIR}/modules/on-game-start.asm"
LW RA, 0x14 (SP)
J @@user_code
ADDIU SP, SP, 0x18
@@user_code:
.include "./${ASM_DIR}/on-game-start.asm"

@on_mario_step_begin:
ADDIU SP, SP, 0xFFE8
SW RA, 0x14 (SP)
.include "./${ASM_DIR}/modules/on-mario-step-begin.asm"
JAL @@user_code
NOP
LW RA, 0x14 (SP)
J 0x8029CA58
ADDIU SP, SP, 0x18
@@user_code:
.include "./${ASM_DIR}/on-mario-step-begin.asm"

@on_mario_step_end:
ADDIU SP, SP, 0xFFE8
SW RA, 0x14 (SP)
.include "./${ASM_DIR}/modules/on-mario-step-end.asm"
LW RA, 0x14 (SP)
J @@user_code
ADDIU SP, SP, 0x18
@@user_code:
.include "./${ASM_DIR}/on-mario-step-end.asm"

@on_frame_end:
ADDIU SP, SP, 0xFFE8
SW RA, 0x14 (SP)
SW A0, 0x18 (SP)
LI T0, 0x8033B050
LHU AT, 0x8032D5D8
SLL AT, AT, 2
ADDU T0, T0, AT
LW A0, 0x0 (T0)
LUI AT, 0x8000
OR A0, A0, AT
SW A0, 0x10 (SP)
.include "./${ASM_DIR}/modules/on-frame-end.asm"
JAL @@user_code
LW A0, 0x10 (SP)
LW A0, 0x18 (SP)
LW RA, 0x14 (SP)
J 0x8027E3E0
ADDIU SP, SP, 0x18
@@user_code:
.include "./${ASM_DIR}/on-frame-end.asm"

@on_hud_render:
ADDIU SP, SP, 0xFFE8
SW RA, 0x14 (SP)
.include "./${ASM_DIR}/modules/on-hud-render.asm"
LW RA, 0x14 (SP)
J @@user_code
ADDIU SP, SP, 0x18
@@user_code:
.include "./${ASM_DIR}/on-hud-render.asm"

@on_level_load:
ADDIU SP, SP, 0xFFE8
SW RA, 0x14 (SP)
.include "./${ASM_DIR}/modules/on-level-load.asm"
JAL @@user_code
NOP
ORI V0, R0, 0x1
LW RA, 0x14 (SP)
JR RA
ADDIU SP, SP, 0x18
@@user_code:
.include "./${ASM_DIR}/on-level-load.asm"

@on_area_load:
ADDIU SP, SP, 0xFFE8
SW RA, 0x14 (SP)
.include "./${ASM_DIR}/modules/on-area-load.asm"
LW RA, 0x14 (SP)
J @@user_code
ADDIU SP, SP, 0x18
@@user_code:
.include "./${ASM_DIR}/on-area-load.asm"

.include "./${ASM_DIR}/modules/injected.asm"
.include "./${ASM_DIR}/modules/mario_actions_airborne.asm"
.include "./${ASM_DIR}/modules/mario_actions_automatic.asm"
.include "./${ASM_DIR}/modules/mario_actions_cutscene.asm"
.include "./${ASM_DIR}/modules/mario_actions_moving.asm"
.include "./${ASM_DIR}/modules/mario_actions_object.asm"
.include "./${ASM_DIR}/modules/mario_actions_stationary.asm"
.include "./${ASM_DIR}/modules/mario_actions_submerged.asm"
.include "./${ASM_DIR}/misc-injected.asm"

.endarea

; Code hook shims

.orga 0x2FD4
J @on_game_start

.orga 0x21CCE8
.word @on_mario_step_begin

.orga 0x57B2C
J @on_mario_step_end

.orga 0x30F4
JAL @on_frame_end

.orga 0x9EE48
J @on_hud_render

.orga 0x6CD0
J @on_level_load

.orga 0x1E8DC
J bbp_mario_actions_stationary
NOP

.orga 0x24998
J bbp_mario_actions_moving
NOP

.orga 0x2AB34
J bbp_mario_actions_airborne
NOP

.orga 0x2F9E8
J bbp_mario_actions_submerged
NOP

.orga 0x187C0
J bbp_mario_actions_cutscene
NOP

.orga 0x1B604
J bbp_mario_actions_automatic
NOP

.orga 0x31024
J bbp_mario_actions_object
NOP

.orga 0x35E5B
.byte 0x37
.orga 0x35E7F
.byte 0x2E
.orga 0x35F30
JAL @on_area_load

.include "./${ASM_DIR}/camera-triggers.asm"
.include "./${ASM_DIR}/modules/shims.asm"
.include "./${ASM_DIR}/modules/global.asm"

.orga 0
.headersize 0x80245000
.include "./${ASM_DIR}/global.asm"

.close
